<template>
  <div class="modal-container" id="changeAddress">
    <div class="modal-header">
      <p class="title">{{ $t(`common.modal.change_${this.coinName}_address.title`) }}</p>
      <button type="button" @click="closeModal()" class="btn-close"><span aria-hidden="true">×</span></button>
    </div>
    <div class="modal-body">
      <div class="form-group">
        <input
          @focus="resetError"
          @keyup.enter="changeAddress"
          data-vv-validate-on="none"
          :data-vv-as="`${this.coinName.toUpperCase()} address`"
          name="address"
          v-validate="`required|is_${this.coinName}_address`"
          :placeholder="$t(`common.modal.change_${this.coinName}_address.placeholder`)"
          class="eth-input"
          v-model="address"
        >
        <span class="invalid-feedback" v-if="errors.has('address')">
          {{ errors.first('address') }}
        </span>
      </div>
      <div class="text-center">
        <button type="button" class="btn btn-submit" @click="changeAddress">{{ $t('common.modal.btn.submit') }}</button>
      </div>
    </div>
  </div>
</template>
<script>
import { mapMutations } from 'vuex';

import rf from '../../../common/requests/RequestFactory';
import OtpConfirmModal from './OtpConfirmModal.vue';

export default {
  props: {
    modalData: {
      type: Object,
      required: true,
    }
  },
  data () {
    return {
      address: '',
    };
  },
  computed: {
    coinName () {
      return this.modalData.currency === 'token' ? 'eth' : this.modalData.currency;
    },
  },
  methods: {
    ...mapMutations([
      'updateUser',
    ]),
    closeModal () {
      this.$broadcast('close-modal');
    },
    resetError () {
      if (this.errors.any()) {
        this.errors.clear();
      }
    },
    changeAddress() {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = Object.assign({}, { address: this.address, currency: this.modalData.currency });
          rf.getRequest('UserRequest').changeAddress(params)
            .then((res) => {
              this.$toasted.show(`Update ${ this.coinName.toUpperCase() } address successful!`, {
                theme: 'bubble',
                position: 'top-right',
                duration : 2000
              });
              this.updateUser(res.data);
              this.closeModal();
            })
            .catch((error) => {
              const errors = error.errors;
              this.errors.clear();
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
              if (this.errors.has('code')) {
                this.$broadcast('open-modal', OtpConfirmModal, {
                  callback: this.requestChangeAddress,
                  key: `requestChange${this.coinName.toUpperCase()}Address`,
                  params: params,
                });
              }
            });
        });
    },
    requestChangeAddress (params) {
      return rf.getRequest('UserRequest').changeAddress(params);
    },
  },
};
</script>
<style lang="scss" scoped>
  @import '../../../../sass/mobile/typoVariables';
  * {
    font-family: $font-family-home;
  }
  #changeAddress {
    width: 270rem;
    height: 245rem;
    border-radius: 10px;
    background: $bg_primary;
    box-shadow: 0 2px 40px 0 rgba(0, 0, 0, 0.18);
    margin: auto;
    .modal-header {
      padding: 0;
      border: none;
      position: relative;
      .title {
        font-size: 16rem;
        font-weight: bold;
        color: #1c1c1c;
        text-align: center;
        line-height: 3.13;
        padding: 31rem 0 5rem;
      }
      .btn-close {
        width: 20rem;
        height: 20rem;
        background-color: #ffffff;
        border: 1px solid #fff;
        border-radius: 50%;
        position: absolute;
        outline: none;
        top: 10rem;
        right: 10px;
        span {
          cursor: pointer;
          color: #989898;
          font-size: 11rem;
        }
      }
    }
    .modal-body {
      margin: 0;
      padding: 0 20rem;
      .form-group {
        text-align: center;
        background: none;
        position: relative;
        padding: 0;
        width: 100%;
        input {
          width: 100%;
          height: 40rem;
          border-radius: 74rem;
          background-color: #ffffff;
          border: none;
          font-size: 13rem;
          padding: 0 20rem;
          outline: none;
          &:placeholder {
            color: #cacaca;
          }
        }
      }
      .btn-submit {
        margin-top: 40rem;
        width: 90rem;
        height: 32rem;
        border-radius: 30rem;
        border: solid 1px #fa7300;
        background: #fff;
        font-size: 12rem;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        letter-spacing: 0.5px;
        color: #fa7300;
        outline: none;
        cursor: pointer;
      }
    }

    .invalid-feedback {
      color: red;
      position: absolute;
      text-align: left;
      font-size: 13rem;
      left: 15rem;
    }
  }
</style>
